#!------------------------------------------------------------------------------
#!                        The C3 Development Template File
#!  Version 1.17   For use with Clarion Database Developer 3.009
#!  These templates are the property of C 3 Development Inc
#!  Copyright 1993,1994 ,All Rights Reserved Worldwide  (c)
#!  Written by Todd Carlson and Bruce Wojak
#!  Unauthorized use or distribution of these templates in any manner
#!  is strictly prohibited without the written permission of its
#!  authors.
#!
#!  C3TMPL.TPL is the first of a chain of template files that contain the
#!  standard C3TMPL procedure templates.
#!
#!  Initial screen, report, and action images are contained in corresponding
#!  application files with an extension of .APP (e.g. C3TMPL.APP).
#!------------------------------------------------------------------------------
#PROGRAM
#!------------------------------------------------------------------------------
#!                           The Program Template
#!The Program template generates the PROGRAM statement, MAP structure, FILE 
#!structures, and global declarations for a Clarion program.  This template 
#!also blanks the screen and calls the first procedure.  There is only one  
#!#PROGRAM segment in a template file chain.                                
#!------------------------------------------------------------------------------
#PROMPT('Enable &Shared Files',CHECK),%SharedFiles
#PROMPT('Create if No File',CHECK),%FileNotFound
#PROMPT('Auto Lookup Key',KEYCODE),%C3alKey
#PROMPT('Many Key Cycle Key',KEYCODE),%C3mkKey
#PROMPT('Glb Hotkey Proc Name',@S20),%C3ghProc
#PROMPT('Close Unused &Files?',CHECK),%CloseFiles
#PROMPT('Len of File Name Str',@s5),%C3FileName
#PROMPT('EXTERNAL Global Data',CHECK),%ExternalData
#PROMPT('View For All Reports',@s20),%C3GlbViewProc
#IF(%FileNotFound)
#SET(%FileNotFound,'Create')
#ELSE
#SET(%FileNotFound,'Halt')
#ENDIF
#IF(%SharedFiles)
  #SET(%AccessMode,'42h')
#ELSE
  #SET(%AccessMode,'22h')
#ENDIF
  #SET(%Mod,(chr(37)))
  #SET(%C3as39,(chr(39)))
  #SET(%C3as44,(chr(44)))
#IF(%ExternalData)
  #SET(%C3ExternalData,(',EXTERNAL(' & %C3as39))
  #SET(%C3ExternalData,(CLIP(%C3ExternalData) & %C3as39))
  #SET(%C3ExternalData,(CLIP(%C3ExternalData) & ')'))
  #SET(%C3ExternalData,',EXTERNAL')
#ENDIF
! Files Required For Program
  #SET(%C3OtherProducts,%NULL)
  #FOR(%AppFiles)
  #IF(UPPER(SUB(%AppFiles,1,2)) <> 'GD' AND UPPER(SUB(%AppFiles,1,2)) <> 'MQ')
  #IF(UPPER(%AppFiles) <> 'OTHERPRODUCTS')
!     %AppFiles
  #ENDIF
  #ENDIF
  #ENDFOR
                TITLE('%Program')
OMIT('')
ͻ
  Program - %Program                          #<!                           
ͼ
                 PROGRAM

                 INCLUDE('KEYCODES.EQU')
                 INCLUDE('CLARION.EQU')
                 INCLUDE('C3EQUATE.EQU')
                 INCLUDE('ERRORS.EQU')
                 #INSERT(%TPequates)
                 include('C3users.equ')     !C3 procedures & functions
!!EMBED('C3 Equates')
#EMBED('C3 Equates')
                 MAP
#IF(%CloseFiles)
                   CheckOpen(FILE),BYTE
#ELSE
                   CheckOpen(FILE)
#ENDIF
                   DiskError(<STRING>),BYTE
                   ShowWarning
                   Spinner
#FIX(%AppFiles,'C3FILE')
#IF(UPPER(%AppFiles) = 'C3FILE')
                   C3FillQueue( QUEUE, <BYTE> ), STRING
                   C3ColumnHead( STRING, LONG ), STRING
#ENDIF
                   include('C3procs.inc')     !C3 procedures & functions
                   module('Clarion Internal Library')
                      SetList(USHORT,USHORT,USHORT),NAME('Cla$SETLIST')
                      GetList(USHORT,*USHORT,*USHORT),NAME('Cla$GETLIST')
                      DeAlert(USHORT,USHORT),NAME('Cla$de_alert')
                   .
                   %ModuleStructures
                   !!EMBED('Inside Global MAP')
                   #EMBED('Inside Global MAP')
                 END

                 EJECT('File Layouts')


%GlobalData
!!EMBED('Before File Declarations')
#EMBED('Before File Declarations')
                   #INSERT(%TPglbdata)

  #SET(%C3GlbFltExists,%NULL)
  #SET(%C3GlbKeyEqExists,%NULL)
  #SET(%C3GlbKeyRgExists,%NULL)
  #SET(%C3GlbPassing,%NULL)
  #SET(%C3TagExists,%NULL)

#FOR(%AppFiles)
   #FIX(%File,%AppFiles)
! File[%File]
   #IF(UPPER(%File) <> 'OTHERPRODUCTS')
      #IF(UPPER(SUB(%File,1,2)) = 'GD' OR UPPER(SUB(%File,1,2)) = 'MQ')
         #IF(UPPER(%File) = 'GD_FILTER')
%File     group,pre(%FilePre)%C3ExternalData
            #SET(%C3GlbFltExists,'TRUE')
            #SET(%C3GlbPassing,'TRUE')
         #ELSIF(UPPER(%File) = 'GD_KEYEQUAL')
%File     group,pre(%FilePre)%C3ExternalData
           #SET(%C3GlbKeyEqExists,'TRUE')
           #SET(%C3GlbPassing,'TRUE')
         #ELSIF(UPPER(%File) = 'GD_KEYRANGE')
%File     group,pre(%FilePre)%C3ExternalData
           #SET(%C3GlbKeyRgExists,'TRUE')
           #SET(%C3GlbPassing,'TRUE')
         #ELSIF(UPPER(%File) = 'GD_TAG')
            #SET(%C3TagExists,'TRUE')
gdt:Tag_R     string(1)%C3ExternalData
gdt:Tag_L     string(1)%C3ExternalData
#SET(%C3FieldFix,'gdt:Tag_R')
#FIX(%Field,%C3FieldFix)
gdtTag_R      equate(%FieldInitial)
#SET(%C3FieldFix,'gdt:Tag_L')
#FIX(%Field,%C3FieldFix)
gdtTag_L      equate(%FieldInitial)
%File     queue,pre(%FilePre)%C3ExternalData
record    group
omit('Tag_L')
         #ELSIF(UPPER(SUB(%File,1,2)) = 'MQ')
%File     queue,pre(%FilePre)%C3ExternalData
         #ELSIF(UPPER(%File) = 'GD_VALID')
         #ELSIF(UPPER(%File) <> 'GD_LOOKUP')
%File     group,pre(%FilePre)%C3ExternalData
         #ENDIF
         #IF(UPPER(%File) = 'GD_LOOKUP')
         #ELSIF(UPPER(%File) = 'GD_VALID')
         #ELSE
record    group
omit('RECORD')
         #ENDIF
      #ENDIF
      #IF(UPPER(%File) <> 'FLAG_ITEMS')
         #IF(%C3FileName)
            #IF(UPPER(SUB(%FileName,1,2)) = 'F_')
               #SET(%C3Value,%FileName)
              #INSERT(%C3ValueType)
               #IF(UPPER(%C3ValueIs) = 'VARIABLE')
%FileName       string(%C3FileName)%C3ExternalData
               #ENDIF
            #ENDIF
         #ENDIF
         #IF(UPPER(%File) = 'GD_LOOKUP')
         #ELSIF(UPPER(%File) = 'GD_VALID')
         #ELSE
%FileStructure
         #ENDIF
      #ELSE
#SET(%C3Flagging,'TRUE')
      #ENDIF
   #ENDIF
#ENDFOR


#IF(%C3Flagging)
#SET(%C3tmpFile,'FLAG_ITEMS')
#FIX(%File,%C3tmpFile)
#IF(%C3FileName)
   #IF(UPPER(SUB(%FileName,1,2)) = 'F_')
      #SET(%C3Value,%FileName)
      #INSERT(%C3ValueType)
      #IF(UPPER(%C3ValueIs) = 'VARIABLE')
%FileName       string(%C3FileName)%C3ExternalData
      #ENDIF
   #ENDIF
#ENDIF
#SET(%C3FileStructure,%FileStructure)
%C3FileStructure
K_fgh            KEY(+fgi:fgh_Sys_ID),dup,nocase
#SET(%C3KeyStructure,%NULL)
#SET(%C3tmpFile,'GD_TAG')
#FIX(%File,%C3tmpFile)
#FOR(%Key)
   #SET(%C3KeyStructure,%Null)
   #SET(%C3KeyStructure,(%Key & ' key('))
   #SET(%C3Key,(INSTRING(':',%Key,1,1) + 1))
   #SET(%C3Key,(SUB(%Key,%C3Key,20)))
   #SET(%C3Key,(CLIP(%C3Key)))
   #SET(%C3KeyStructure,(UPPER(%C3Key) & ' KEY(+FGI:FGH_SYS_ID'))
   #SET(%C3KeyStructure,(CLIP(%C3KeyStructure)))
   #FOR(%KeyField)
      #IF(%KeyFieldSequence = 'DESENDING')
         #SET(%C3AscDes,'-')
      #ELSE
         #SET(%C3AscDes,'+')
      #ENDIF
      #SET(%C3KeyField,(INSTRING(':',%KeyField,1,1) + 1))
      #SET(%C3KeyField,('FGI:' & SUB(%KeyField,%C3KeyField,20)))
      #SET(%C3KeyField,(CLIP(%C3KeyField)))
      #SET(%C3KeyStructure,(%C3KeyStructure & ',' & %C3AscDes & %C3KeyField))
      #SET(%C3KeyStructure,(CLIP(%C3KeyStructure)))
   #ENDFOR
   #SET(%C3KeyStructure,(%C3KeyStructure & '),DUP,NOCASE'))
%C3KeyStructure
#ENDFOR
RECORD         RECORD
FGH_SYS_ID          long
OMIT('Tag_L')
%FileStructure
#ENDIF
#IF(%C3GlbFltExists)
   #SET(%C3FltFile, 'GD_FILTER')
   #FIX(%File,%C3FltFile)
   #FOR(%Field)
GDF:c%FieldID  BYTE(0)%C3ExternalData
   #ENDFOR
#ENDIF

C3_Inv_KeyCode   LONG%C3ExternalData
C3_Inv_Field     LONG%C3ExternalData
C3_Inv_Row       SHORT%C3ExternalData
C3_Inv_Rows      SHORT%C3ExternalData
C3_Inv_Col       SHORT%C3ExternalData
C3_Inv_Cols      SHORT%C3ExternalData
C3_Inv_MRow      BYTE%C3ExternalData
C3_Inv_MCol      BYTE%C3ExternalData

AddRecord        EQUATE(1)                     #<!  Add a new record
ChangeRecord     EQUATE(2)                     #<!  Change the current record
DeleteRecord     EQUATE(3)                     #<!  Delete the current record
SelectRecord     EQUATE(4)                     #<!  Select the current record

Gby_Reverse      BYTE(0)%C3ExternalData

#INSERT(%C3GlobVariables)
!!EMBED('Data Section')
#EMBED('Data Section')


Spin_Scr         SCREEN(5,26),CENTER,SHADOW,COLOR(112)
                   ROW(1,1)    STRING('{26}'),COLOR(113)
                   ROW(3,4)    STRING('Processing Records')
                   ROW(5,1)    STRING('{24}'),COLOR(113)
                               REPEAT(3)
                   ROW(2,1)      STRING(''),COLOR(113)
                   ROW(2,26)     STRING(''),COLOR(113)
                               .
                 .

  CODE
  !!EMBED('Setup Program')
  #EMBED('Setup Program')
  LOADSYMBOLS                                  #<!Display graphic mouse
  IF G_e_EnhanceBckgrd
     SETNOBLINK                                   #<!Enable enhanced colors
  ELSE
     SETBLINK
  END
  #IF(%HelpFile)
     HELP('%HelpFile')                            #<!Open the help file
  #ENDIF
  #IF(%StyleFile )
     GETSTYLES('%StyleFile')                      #<!Open the style file
  #ENDIF
  IF G_e_MouseSupport
     SETMOUSE(1,1)                                #<!Turn on mouse
  END
  SETCOLOR(WhiteOnBlack)                       #<!Set white on black
  BLANK                                        #<!Clear the screen
  SETCOLOR                                     #<!Turn off override color
  %FirstProcedure                              #<!Call the first procedure
  !!EMBED('Before return to DOS')
  #EMBED('Before return to DOS')
  RETURN                                       #<!Return to DOS
OMIT('')
ͻ
  Check ERROR() function after opening a file                               
ͼ
#IF(%CloseFiles)                                #!Generate function for close
CheckOpen         FUNCTION(File)
LOC::ReturnVal    BYTE(0)

  CODE
  !!EMBED('CheckOpen: Setup Procedure')
  #EMBED('CheckOpen: Setup Procedure')
  OPEN(File,%AccessMode)                       #<!Attempt to open the file
  CASE ERRORCODE()                             #<! and check for errors
  OF NoError                                   #<!Return opened flag
    !!EMBED('CheckOpen: No Error')
    #EMBED('CheckOpen: No Error')
    LOC::ReturnVal = True
    DO ProcedureReturn                           ! signal successful open
  OF IsOpenErr                                 #<! or if already open.
    !!EMBED('CheckOpen: File Open Error')
    #EMBED('CheckOpen: File Open Error')
    DO ProcedureReturn
  #IF(UPPER(%FileNotFound) <> 'HALT')
  OF NoFileErr                                 #<!If file was not found
    !!EMBED('CheckOpen: No File Error')
    #EMBED('CheckOpen: No File Error')
    CREATE(File)                               #<!Create the file
    IF ERRORCODE()
      #INSERT(%CreateFailureMsg)
    END
    OPEN(File,%AccessMode)                     #<! then open it
    IF ~ERRORCODE()                            #<!  And return if it opened
      LOC::ReturnVal = True
      DO ProcedureReturn                         ! signal successful open
    ELSE
      HALT(ERRORCODE())
    END
  #ENDIF
  OF InvalidFileErr                            #<!Invalid Record Declaration
    !!EMBED('CheckOpen: Invalid File Error')
    #EMBED('CheckOpen: Invalid File Error')
    #INSERT(%InvalidFileMsg)
    HALT(InvalidFileErr)
  OF BadKeyErr                                 #<!Key Files must be rebuilt
    !!EMBED('CheckOpen: Bad Key Error')
    #EMBED('CheckOpen: Bad Key Error')
    #INSERT(%BadKeyMsg)
    OPEN(File,12H)                               !Open for exclusive access
    IF ERRORCODE() <> BadKeyErr
      #INSERT(%KeyBuildErrorMsg)
      HALT(BadKeyErr)
    END
    BUILD(File)                                  !Rebuild the key files
    IF ERRORCODE()
      GLO:Message1 = NAME(File) & ' Encountered an Error '
      GLO:Message2 = 'while being repaired '
      GLO:Message3 = 'Error: ' & ERROR()
      ShowWarning
      HALT(BadKeyErr)
    ELSE
      CLOSE(File)                                !Close
      OPEN(File,%AccessMode)                   #<! then re-open it
      LOC::ReturnVal = True
      DO ProcedureReturn                         ! signal successful open
    END
  END                                          #<!End of Case Structure
  IF DiskError(NAME(File) & ' File could not be opened') THEN HALT(0). #<!Cannot resume
  DO ProcedureReturn
ProcedureReturn ROUTINE
  !!EMBED('CheckOpen: Directly before return')
  #EMBED('CheckOpen: Directly before return')
  RETURN(LOC::ReturnVal)
#ELSE                                           #!Generate procedure
CheckOpen         PROCEDURE(File)

  CODE
  !!EMBED('CheckOpen: Setup Procedure')
  #EMBED('CheckOpen: Setup Procedure')
  OPEN(File,%AccessMode)                       #<!Attempt to open the file
  CASE ERRORCODE()                             #<! and check for errors
  OF NoError                                   #<!Return if no error
    !!EMBED('CheckOpen: No Error')
    #EMBED('CheckOpen: No Error')
  OROF IsOpenErr                               #<! or if already open.
    !!EMBED('CheckOpen: File Open Error')
    #EMBED('CheckOpen: File Open Error')
    DO ProcedureReturn
  #IF(UPPER(%FileNotFound) <> 'HALT')
  OF NoFileErr                                 #<!If file was not found
    !!EMBED('CheckOpen: No File Error')
    #EMBED('CheckOpen: No File Error')
    CREATE(File)                               #<!Create the file
    IF ERRORCODE()
      #INSERT(%CreateFailureMsg)
    END
    OPEN(File,%AccessMode)                     #<! then open it
    IF ~ERRORCODE()                            #<!  And return if it opened
      DO ProcedureReturn
    ELSE
      HALT(ERRORCODE())
    END
  #ENDIF
  OF InvalidFileErr                            #<!Invalid Record Declaration
    !!EMBED('CheckOpen: Invalid File Error')
    #EMBED('CheckOpen: Invalid File Error')
    #INSERT(%InvalidFileMsg)
    HALT(InvalidFileErr)
  OF BadKeyErr                                 #<!Key Files must be rebuilt
    !!EMBED('CheckOpen: Bad Key Error')
    #EMBED('CheckOpen: Bad Key Error')
    #INSERT(%BadKeyMsg)
    OPEN(File,12H)                             #<!Open for exclusive access
    IF ERRORCODE() <> BadKeyErr
      #INSERT(%KeyBuildErrorMsg)
      HALT(BadKeyErr)
    END
    BUILD(File)                                #<!Rebuild the key files
    IF ERRORCODE()
      GLO:Message1 = NAME(File) & ' Encountered an Error '
      GLO:Message2 = 'while being repaired '
      GLO:Message3 = 'Error: ' & ERROR()
      ShowWarning
      HALT(BadKeyErr)
    ELSE
      CLOSE(File)                              #<!Close
      OPEN(File,%AccessMode)                   #<! then open it
    END
  END                                          #<!End of Case Structure
  IF DiskError(NAME(File) & ' File could not be opened') THEN HALT(0). #<!Cannot resume
  DO ProcedureReturn
ProcedureReturn ROUTINE
  !!EMBED('CheckOpen: Directly before return')
  #EMBED('CheckOpen: Directly before return')
  RETURN
#ENDIF

OMIT('')
ͻ
  Check ERROR() function after a disk access                                
ͼ
DiskError        FUNCTION(Cause)
StopMsg::        STRING(198),AUTO,STATIC
LOC::ReturnVal   BYTE(0)

  CODE
  !!EMBED('DiskErr: Setup Procedure')
  #EMBED('DiskErr: Setup Procedure')
  IF ~ERRORCODE() THEN DO ProcedureReturn.     #<!Return with no error
  IF ~OMITTED(1)                               #<!If a cause was given
    StopMsg:: = 'Cause: ' & Cause & LF:CR      #<!  Display it
  END                                          #<!End IF
  IF ERRORFILE()                               #<!If error involves a file
    StopMsg:: = CLIP(StopMsg::) & 'File : '  | #<!  display the file
              & ERRORFILE() & LF:CR
  END                                          #<!End IF
  StopMsg:: = CLIP(StopMsg::) & 'Error: '    | #<!Display the error code
            & ERRORCODE() & ' - '            | #<!  and the error message
            & ERROR() & LF:CR

  STOP(StopMsg::)                              #<!Stop with message
  LOC::ReturnVal = True                        #<!Return with error
  DO ProcedureReturn
ProcedureReturn ROUTINE
  !!EMBED('DiskErr: Directly before return')
  #EMBED('DiskErr: Directly before return')
  RETURN(LOC::ReturnVal)

OMIT('')
ͻ
  Display a warning message using 3 Global message variables.               
ͼ
ShowWarning      PROCEDURE
SaveStyle        STRING(256)
Screen           SCREEN(9,53),PRE(SCR),CENTER,SHADOW,CUA,COLOR(112)
                   ROW(1,1)    STRING('{51}'),COLOR(116)
                   ROW(9,1)    STRING('{51}'),COLOR(116)
                               REPEAT(7)
                   ROW(2,1)      STRING(''),COLOR(116)
                   ROW(2,53)     STRING(''),COLOR(116)
                               .
                   ROW(3,5)    ENTRY(@S45),USE(GLO:Message1),INS,SKIP,COLOR(112,112,112)
                   ROW(4,5)    ENTRY(@S45),USE(GLO:Message2),INS,SKIP,COLOR(112,112,112)
                   ROW(5,5)    ENTRY(@s45),USE(GLO:Message3),INS,SKIP,COLOR(112,112,112)
                   ROW(7,24)   BUTTON('  &Ok  |'),SHADOW,USE(?Ok),COLOR(23,71,24,31,79)
                 .

  CODE
  !!EMBED('ShowWarning: Setup Procedure')
  #EMBED('ShowWarning: Setup Procedure')
  SaveStyle = STYLES()                         #<!Save current style
  GETSTYLES('')                                #<!Turn off Styles
  GLO:Message1 = CENTER(GLO:Message1,SIZE(GLO:Message1))
  GLO:Message2 = CENTER(GLO:Message2,SIZE(GLO:Message2))
  GLO:Message3 = CENTER(GLO:Message3,SIZE(GLO:Message3))
  !!EMBED('ShowWarning: Before Screen Opening')
  #EMBED('ShowWarning: Before Screen Opening')
  OPEN(Screen)
  DISPLAY
  ACCEPT                                       #<!Enable keyboard and mouse
  !!EMBED('ShowWarning: After Accept')
  #EMBED('ShowWarning: After Accept')
  CLEAR(GLO:MessageGroup)                      #<!Blank out message fields
  SETSTYLES(SaveStyle)                         #<!Restore user styles
  DO ProcedureReturn
ProcedureReturn ROUTINE
  !!EMBED('ShowWarning: Directly before return')
  #EMBED('ShowWarning: Directly before return')
  RETURN

Spinner           procedure

       code
       IF Gby_SpinRow AND Gby_SpinCol
       Gby_SpinCnt += 1
       EXECUTE Gby_SpinCnt
          SHOW(Gby_SpinRow,Gby_SpinCol,'|')
          SHOW(Gby_SpinRow,Gby_SpinCol,'/')
          SHOW(Gby_SpinRow,Gby_SpinCol,'-')
          SHOW(Gby_SpinRow,Gby_SpinCol,'\')
       END
       IF Gby_SpinCnt = 4
          Gby_SpinCnt = 0
       END
       END
       RETURN

#FIX(%AppFiles,'C3FILE')
#IF(UPPER(%AppFiles) = 'C3FILE')
C3FillQueue        FUNCTION( FldQueue, HeaderFlag )

C3TmpBldString STRING( 255 )
C3TmpPicture  cstring( '@pXXXXXXXXXXXXXXXXXXXXp' )
C3QPointer    BYTE( 0 )
C3FieldLen    BYTE( 0 )
C3RetLen      BYTE( 0 )
C3FieldNum    LONG( 0 )
tFieldVal     STRING( 255 )

TmpFlds       GROUP,PRE( _tf )
FileName         STRING( 20 )
FieldNumber      STRING( 10 )
FieldPicture     STRING( 20 )
              .

       CODE
       CLEAR( C3TmpBldString )
       LOOP C3QPointer = 1 TO RECORDS( FldQueue )
          GET( FldQueue, C3QPointer )
          TmpFlds = FldQueue
          C3FieldNum = DEFORMAT( _tf:FieldNumber, @n010 )
          C3TmpPicture = LEFT( CLIP( _tf:FieldPicture ) )
          IF INSTRING( '@S', UPPER( c3TmpPicture ), 1, 1 )
             IF UPPER( _tf:FileName ) = 'SEPERATOR'
                C3FieldLen = 3
                IF ~OMITTED( 2 )
                   tFieldVal = '   '
                ELSE
                   tFieldVal = '  '
                .
             ELSE
                C3FieldLen = LEN( C3FieldValue( _tf:FileName, C3FieldNum ) )
                IF ~OMITTED( 2 )
                   tFieldVal = C3ColumnHead( _tf:FileName, C3FieldNum )
                ELSE
                   tFieldVal = C3FieldValue( _tf:FileName, C3FieldNum )
                .
             .
          ELSE
             C3FieldLen = LEN( FORMAT( C3FieldValue( _tf:FileName, C3FieldNum ), C3TmpPicture ) )
             IF ~OMITTED( 2 )
                tFieldVal = C3ColumnHead( _tf:FileName, C3FieldNum )
             ELSE
                tFieldVal = FORMAT( C3FieldValue( _tf:FileName, C3FieldNum ), C3TmpPicture )
             .
          .
          IF ~C3TmpBldString
             C3TmpBldString = tFieldVal
          ELSE
             C3TmpBldString = SUB( C3TmpBldString, 1, C3RetLen ) & tFieldVal
          .
          C3RetLen += C3FieldLen
       .
       RETURN( C3TmpBldString )

C3ColumnHead       FUNCTION( FileName, FieldNumber )

#IF(%CloseFiles)
cfd:Opened    BYTE( 0 )
cfl:Opened    BYTE( 0 )
#ENDIF

       CODE
       #IF(%CloseFiles)
       cfd:Opened = CheckOpen( C3Field )
       cfl:Opened = CheckOpen( C3File )
       #ELSE
       CheckOpen( C3Field )
       CheckOpen( C3File )
       #ENDIF
       cfl:FileName = FileName
       GET( C3File, cfl:K_FileName )
       cfd:cflSys_ID = cfl:Sys_ID
       cfd:FieldNumber = FieldNumber
       GET( C3Field, cfd:K_cflSys_ID_Field )
       #IF( %CloseFiles )
       IF cfd:Opened THEN CLOSE( C3Field ).
       IF cfl:Opened THEN CLOSE( C3File ).
       #ENDIF
       RETURN( cfd:FieldColumnHead )
#ENDIF

#MODULE
#!------------------------------------------------------------------------------
#!                            The Module Template
#!The Module template generates the MEMBER statement, and module level data 
#!declarations for a source module of a Clarion program.  There is only one 
#!#MODULE segment in a template file chain.                                 
#!------------------------------------------------------------------------------
                MEMBER('%Program')
OMIT('')
ͻ
   %Module - %ModuleDescription               #<!                           
ͼ
%ModuleData
!!EMBED('Data Section')
#EMBED('Data Section')
#CHAIN('batch.c3x')
