$COMPILE DLL

$INCLUDE "WINAPI.INC"

DECLARE FUNCTION InputDlgProc(BYVAL hDlg AS INTEGER, _
                              BYVAL wMsg AS INTEGER, _
                              BYVAL wParam AS INTEGER, _
                              BYVAL lParam AS LONG) AS INTEGER


GLOBAL UserName     AS ASCIIZ * 255
GLOBAL DlgAddr      AS DWORD
GLOBAL hCurInstance AS WORD

FUNCTION LibMain (BYVAL hInstance AS INTEGER, _
                  BYVAL wDataSeg AS WORD, _
                  BYVAL wHeapSize AS WORD, _
                  lpszCmdLine AS ASCIIZ) EXPORT AS INTEGER

  'Save the instance handle of the DLL
  hCurInstance = hInstance

  'Remember! We have to return a "one" to indicate successful
  '          initialization
  LibMain      = 1   'success!

END FUNCTION


SUB ModalTest(InitValue AS ASCIIZ) EXPORT

  ' Get the address of the dialog callback
  DlgAddr = MakeProcInstance(CODEPTR(InputDlgProc), hCurInstance)

  ' If an initial value was passed, assign it to the edit box
  IF LEN(InitValue) THEN
    UserName = InitValue
  END IF

  ' Pop up the modal dialog
  DialogBox hCurInstance, "MODALTEST", 0, DlgAddr

  ' Assign the return value
  InitValue = UserName

END SUB


' **
' ** Generic routine to center any window given its handle.
' **
SUB CenterWindow(BYVAL hWnd AS WORD)

  DIM WndRect AS RECT
  DIM x       AS INTEGER
  DIM y       AS INTEGER

  GetWindowRect hWnd, WndRect

  x = (GetSystemMetrics(%SM_CXSCREEN)-(WndRect.nRight-WndRect.nLeft))\2
  y = (GetSystemMetrics(%SM_CYSCREEN)-(WndRect.nBottom-WndRect.nTop+GetSystemMetrics(%SM_CYCAPTION)))\2

  SetWindowPos hWnd, %NULL, x, y, 0, 0, %SWP_NOSIZE OR %SWP_NOZORDER

END SUB


FUNCTION InputDlgProc(BYVAL hDlg AS INTEGER, _
                      BYVAL wMsg AS INTEGER, _
                      BYVAL wParam AS INTEGER, _
                      BYVAL lParam AS LONG) EXPORT AS INTEGER

  SELECT CASE wMsg
    CASE %WM_INITDIALOG
      'Center the window
      CenterWindow hDlg
      'assign the initial value to the edit box
      SetWindowText GetDlgItem(hDlg, 102), UserName
      FUNCTION = 1
      EXIT FUNCTION

    CASE %WM_COMMAND
      SELECT CASE wParam
        'When the "DONE" button is pressed, get the edit box value
        ' and end the dialog
        CASE 103
          GetWindowText GetDlgItem(hDlg, 102), UserName, 255
          EndDialog hDlg, 1
          FUNCTION = 1
          EXIT FUNCTION
      END SELECT
  END SELECT

END FUNCTION
