Option Explicit
Declare Function WinExec Lib "Kernel" (ByVal lpCmdLine As String, ByVal nCmdShow As Integer) As Integer
Declare Function GetModuleUsage Lib "Kernel" (ByVal hModule As Integer) As Integer

Sub Logit (Fn As String, Cause As String, Errmsg As String)
    
    Dim Fi As Integer
    Fi = FreeFile
    Open Fn For Append As #Fi
    Print #Fi, Cause, Now
    Print #Fi, , Errmsg
    Close Fi
End Sub

Sub Main ()
   Dim Phoneentry As String
   Dim Errorfile As String
   Dim Username  As String
   Dim Password As String
   Dim Domain As String
   Dim Logfile As String
   Dim Job As String

   Dim Argc As Integer
   Dim Doit As Integer
   Dim Buffer As String
   Dim Errormsg As String
   Dim Fi As Integer
   Dim hinst As Integer
   Buffer = ""
   Argc = 0
   Doit = ParsecmdLine(Command$, Buffer)
   Do While Doit
        Select Case Argc
            Case 0
                Phoneentry = Buffer
            Case 1
                Username = Buffer
            Case 2
                Password = Buffer
            Case 3
                Domain = Buffer
            Case 4
                Job = Buffer
            Case 5
                Errorfile = Buffer
            Case 6
                Logfile = Buffer
            Case Else
        End Select
        Argc = Argc + 1
        Doit = ParsecmdLine("", Buffer)
   Loop
   If Phoneentry = "" Then Exit Sub

   If Errorfile = "" Then Errorfile = "RasError.Log"
   If Logfile = "" Then Logfile = "RasLog.Log"
   Call Logit(Logfile, "STATUS", "Dial started: " & Phoneentry)
   Doit = SyDialRas(Phoneentry, Username, Password, Domain, Errormsg)
   If Not Doit Then
        Call Logit(Errorfile, "RASERROR", Errormsg)
        Exit Sub
   End If
   If Job <> "" Then
        Call Logit(Logfile, "STATUS:", "Job started:" & Job)
        Ras.Status = "Starting job " & Job
        Beep
        DoEvents
        hinst = shellwait(Job & " " & Errorfile & " " & Logfile, 1, Errormsg)
        If hinst <= 32 And hinst >= 0 Then
            Call Logit(Errorfile, "JOBERROR", Errormsg)
        Else
            Call Logit(Logfile, "STATUS:", "Job ended:" & Job)
            Ras.Status = "Job endet"
            Beep
            DoEvents
        End If
   End If

   SyRasHangup
   Call Logit(Logfile, "STATUS", "Ended: " & Phoneentry)
End Sub

Function ParsecmdLine (ByVal Source As String, Buffer As String) As Integer
'
'   Simple Visual Basic implementation for parsing a commandline
'
'   Input:
'       Srce$  - text string to be parsed (first time)
'                a null string (subsequent calls)
'   Delimiters are: Space
'                   Pairs of " are allowed
'
'   Function return:    next token, or null string if no more
'
'   Restrictions:       not reentrant
'
    Dim BegPos As Integer
    Dim Endpos As Integer
    Dim ln As Integer
    Static Start As Integer
    Static Savestr As String
    Dim Delim As String
    ' If first call, make a copy of the string.

    If Source <> "" Then
        Start = 1
        Savestr = Trim(Source)
    End If

    BegPos = 1
    ln = Len(Savestr)
    
    ' Look for start of a token (character that isn't delimiter).

    Do While (BegPos <= ln) And Mid$(Savestr, BegPos, 1) = " "
        BegPos = BegPos + 1
    Loop

    ' Test for token start found.

    If BegPos > ln Then

        ParsecmdLine = False                     'no more string to search
        Buffer = ""
        Exit Function
    Else
        If BegPos > 1 Then
            Savestr = Mid$(Savestr, BegPos)
        End If
        Delim = " "
        If Left$(Savestr, 1) = Chr$(34) Then
            Delim = Chr$(34)
            Savestr = Mid$(Savestr, 2)
        End If
        ln = Len(Savestr)
        If ln = 0 Then
            ParsecmdLine = False
            Buffer = ""
            Exit Function
        End If
        ' Find the end of the token.

        Endpos = 1

        While Endpos <= ln And Mid$(Savestr, Endpos, 1) <> Delim
            Endpos = Endpos + 1
        Wend

        ParsecmdLine = True
        Buffer = Left(Savestr, Endpos - 1)
        Savestr = Mid$(Savestr, Endpos + 1)
    End If

End Function

'****************************************************************************
'* Funktion :                                                               *
'*          :                                                               *
'* Parameter: lpCmd ......                                                  *
'*          : nCmdShow ...                                                  *
'*          : Errstr .....                                                  *
'*          :                                                               *
'* Returns  :                                                               *
'*          :                                                               *
'* History  : Standard-Header                                  06-06-95 KAT *
'****************************************************************************
Function shellwait (lpCmd As String, nCmdShow As Integer, ErrStr As String) As Integer
   Dim hinst As Long

   DoEvents
   hinst = WinExec(lpCmd, nCmdShow)
   If hinst <= 32 And hinst >= 0 Then
      ErrStr = "Link Error: " + Error$ + " " + Format(hinst, "####0")
      shellwait = hinst
      Exit Function
   End If
   DoEvents
   Do While GetModuleUsage(hinst) > 0
     DoEvents
   Loop
   shellwait = hinst
End Function

