''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Sync routines for PowerBASIC 3.x
' Copyright (c) 1996 by Dave Navarro, Jr.  All Rights Reserved.
'
' This .OBJ allows PowerBASIC programmers to syncronize loops with the BIOS
' tick counter.  After performing all of your operations in a loop, call
' SyncWait() at the end of the loop to wait until the specified number of
' timer ticks has passed.  Unlike a standard TickDelay() call, the timer
' ticks will count down "while your code is processing data".  This allows
' a loop to execute a single iteration every "n" ticks no matter what CPU
' is in use.
'
' I am releasing this sample code and binary object file (.OBJ) as Freeware.
' Feel free to use them in you own programs without requirement of any
' payment to the author.
'
' If you have any questions or suggestions, I can be reached via Internet
' email at:  dave@powerbasic.com
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

$LINK "SYNC.OBJ"

DECLARE SUB SyncOn(BYVAL ticks AS INTEGER)
DECLARE SUB SyncOff()
DECLARE Sub SyncWait()

SyncOn 18 'a full second

DO
  '
  ' Code which runs at different speeds on different CPU's
  ' goes here
  '
  PRINT TIME$
  '
  '
  '
  '

  SyncWait    'Wait until a full second has passed since the last time
              'SyncWait was called

LOOP UNTIL LEN(INKEY$)

SyncOff
